#include "prolog.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include "errors.h"
//#include "rpctypes.h"
#include "swaplib.h"
//#include "almsrv.h"
#include "toolkit.h"
#include "wkseqm.h"
#include "cdi.h"

int tempId = -1;
short gTempRb[100];

int hdwIoDebugLevel = 0;
void tempCb(int id,int cc)
{
  int i;
  static int nr = 0;

  nr++;
  //if (hdwIoDebugLevel) 
  printf("temp cb id %d nr %d : %d\n", id, nr, cc);
  printf("%d %d %d %d\n",gTempRb[0],gTempRb[1],gTempRb[2],gTempRb[3]);

  /* the gTempRb() buffer won't have anything in it unless I have real hardware, so fake it: */
  for (i=0; i<PRP_TEMP_SIZE; i++)
  {
    g_tempBuffer[i] = (float)(20 + rand()%5);
  }
}
int startHdwIoMonitor(void)
{
  DTYPE dout,din;
  
  din.dArrayLength = 0;
  din.dFormat = CF_NULL;
  din.data.vptr = NULL;
  
  dout.dArrayLength = PRP_TEMP_SIZE;
  dout.dFormat = CF_SHORT;
  dout.data.sptr = gTempRb;
  
  /* 
     read the temperatures from the CDI hardware
     this will do 100 reads over the device range given
  */
  tempId = AttachLinkEx("/localhost/cdi/#1-#5", "RECV", &dout, &din, CA_READ, 1000, tempCb, CM_POLL, 1);
  if (tempId < 0) 
  {
    feclog("error in starting monitor : %s",erlst[-tempId]);
    return -tempId;
  }  
  return 0;
}

int getValues(char *hwDevName,short *outputValues,int numValues)
{
  DTYPE dout,din;
  char devName[132];

  if (hwDevName == NULL || numValues <= 0 || outputValues == NULL) return argument_list_error;

  sprintf(devName,"/localhost/cdi/%s",hwDevName);
  din.dArrayLength = 0;
  din.dFormat = CF_NULL;
  din.data.vptr = NULL;
  
  dout.dArrayLength = numValues;
  dout.dFormat = CF_SHORT;
  dout.data.sptr = outputValues;
  
  return ExecLinkEx(devName,"RECV",&dout,&din,CA_READ,100);
}
int setValue(char *hwDevName, short inputValue)
{
  DTYPE dout,din;
  char devName[132];

  if (hwDevName == NULL) return argument_list_error;

  sprintf(devName,"/localhost/cdi/%s",hwDevName);

  dout.dArrayLength = 0;
  dout.dFormat = CF_NULL;
  dout.data.vptr = NULL;
  
  din.dArrayLength = 1;
  din.dFormat = CF_SHORT;
  din.data.sptr = &inputValue;
    
  return ExecLinkEx(devName, "SEND", &dout, &din, CA_WRITE, 100);
}

